package l10_concurrent;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class ScheduledExecutorsExample {
	private static long timeStart = 0;

	public static void main(String[] args) {
		final long nano = 1000000000L; // nano -> sec
		final int timeInterval = (args.length == 0) ? 5 : Integer.parseInt(args[0]);
		//	The java.lang.System.nanoTime() method returns the current value of
		//	the most precise available system timer, in nanoseconds. The value
		//	returned represents nanoseconds since some fixed but arbitrary time
		//	(in the future, so values may be negative) 

		Runnable task = new Runnable() {
			@Override
			public void run() {
				long timeStop = System.nanoTime() / nano;
				System.out.println("Executing task at " + timeStop);
				System.out.println("Time elapsed: " + (timeStop - timeStart));
			}
		};

		try (ScheduledExecutorService scheduledExecutorService = Executors.newScheduledThreadPool(1)) {
			timeStart = System.nanoTime() / nano;
			System.out.println("Submitting task at " + timeStart +
					" to be executed after " + timeInterval + " seconds");
			scheduledExecutorService.schedule(task, timeInterval, TimeUnit.SECONDS);
		}
	}
}

